unit WerCrt;

interface
uses Forms, Graphics, StdCtrls;

const
  Colors:array[0..15] of TColor=(
$00000000,$00A80000,$0000A800,$00A8A800,$000000A8,$00A800A8,$000054A8,$00A8A8A8,
$00545454,$00FC5454,$0054FC54,$00FCFC54,$005454FC,$00FC54FC,$0054FCFC,$00FCFCFC);

  Black       = 0;
  Blue        = 1;
  Green       = 2;
  Cyan        = 3;
  Red         = 4;
  Magenta     = 5;
  Brown       = 6;
  LightGray   = 7;
  DarkGray    = 8;
  LightBlue   = 9;
  LightGreen  =10;
  LightCyan   =11;
  LightRed    =12;
  LightMagenta=13;
  Yellow      =14;
  White       =15;

var
  Screen:array[1..25,1..80]of record c:char;a:byte end;
  Labels:array[1..25,1..80]of TLabel;
  TextAttr: byte=7;
  WhereX:byte=1;
  WhereY:byte=1;
  MaxX,MaxY:byte;
  Form: TForm;

procedure ClrScr;
procedure TextColor(Color:byte);
procedure TextBackGround(Color:byte);
procedure Write(const s:string);
procedure WriteLn(const s:string='');

procedure SetForm(F:TForm);
procedure Draw;

function St(i:integer;len:byte=0;c:char='0'):string;

implementation

procedure ClrScr;
var i,j:byte;
begin
for i:=1 to 25 do
  for j:=1 to 80 do
    begin
    Screen[i,j].c:=' ';
    Screen[i,j].a:=TextAttr;
    end;
end;

procedure TextColor(Color:byte);
begin
  TextAttr:=(TextAttr and $F0) or Color;
end;

procedure TextBackGround(Color:byte);
begin
  TextAttr:=(TextAttr and $0F) or Color*$10;
end;

procedure Write(const s:string);
var i:byte;
begin
  for i:=1 to length(s) do
   case s[i] of
    #13:WhereY:=1;
    #10:Inc(WhereX);
    else
      begin
      Screen[WhereX,WhereY].c:=s[i];
      Screen[WhereX,WhereY].a:=TextAttr;
      inc(WhereY);
      if WhereY>80 then
        begin
        WhereY:=1;
        Inc(WhereX);
        end;
      end;
    end;
end;

procedure WriteLn(const s:string='');
begin
  Write(s);
  WhereY:=1;
  Inc(WhereX);
end;

procedure SetForm(F:TForm);
begin
  Form:=F;
end;

procedure Draw;
var i,j:byte;
begin
  for i:=1 to 25 do
    for j:=1 to 80 do
     if(Screen[i,j].a div 16<>0)or not(Screen[i,j].c in [' ',#0])then
      begin
      if i>MaxX then MaxX:=i;
      if j>MaxY then MaxY:=j;
      if Labels[i,j]=nil then
        begin
        Labels[i,j]:=TLabel.Create(Form);
        with Labels[i,j] do
          begin
          Font:=Form.Font;
          Canvas.Font:=Font;
          Parent:=Form;
          Top:=(i-1)*Canvas.TextHeight('Wq^!_l|');
          Left:=(j-1)*Canvas.TextWidth('W');
          if Parent is TForm then
            begin
            OnClick:=TForm(Parent).OnClick;
            OnMouseDown:=TForm(Parent).OnMouseDown;
            OnMouseUp:=TForm(Parent).OnMouseUp;
            end;
          end;
        end;
      with Labels[i,j] do
        begin
        Caption:=Screen[i,j].c;
        Color:=Colors[Screen[i,j].a div 16];
        Font.Color:=Colors[Screen[i,j].a mod 16];
        end;
      end;
end;

function St(i:integer;len:byte=0;c:char='0'):string;
var s:string;
begin
  Str(i,s);
  while length(s)<len do
    s:=c+s;
  Result:=s;
end;

end.
